#include "taskmanager.hh"

void taskmanager::insert(task *n)
{
	tasks.push_back(n);
}

bool taskmanager::tick()
{
    list<task *>::iterator i, j;
    for(i=tasks.begin(); i!=tasks.end(); i = j)
    {
    	j = i;
    	++j;
    	if(!(*i)->tick())
    	{
    		delete *i;
    		tasks.erase(i);
    	}
    }
    return true;
}

taskmanager::~taskmanager()
{
	list<task *>::iterator i;
	for(i=tasks.begin(); i!=tasks.end(); ++i)
		delete *i;
}

void taskmanager::operator += (const event &ev)
{
	list<task *>::iterator i;
    switch(ev.what())
	{
		case E_GLOBAL:
		{
		    string s = ev.getdata("");
	        for(i=tasks.begin(); i!=tasks.end(); ++i)
	            (*i)->echo(s);
	        break;
		}
		default:
			break;
	}
}
