#include <iostream>
#include <unistd.h>

#include "task.hh"
#include "taskmanager.hh"
#include "servertask.hh"
#include "events.hh"

class taskmanager taskmanager;

class systemtask : public task
{
	unsigned n;
public:
	systemtask()
	{
		cout << "System task started.\n";
		n=0;
	}
    virtual bool tick()
    {
    	if(!(++n % 200))
    		taskmanager += globalevent("The vision bends abnormally a bit for a while.");
       	return true;
   	}
};

int main(void)
{
	taskmanager.insert(new systemtask());
	taskmanager.insert(new servertask(6135));
	
	while(taskmanager.tick())
		usleep(20000);
	
	return 0;
}
